Bug 177385 - writing to loop mounted filesystems doesnt update underlying file modify time
writing to loop mounted filesystems doesnt update underlying file modify time
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
14
i686 Linux
medium Severity high
: ---
: ---
Assigned To: Alexander Viro
Brian Brock
bzcl34nup
: Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-01-10 03:14 EST by JW
Modified: 2012-08-16 17:38 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-16 17:38:03 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description JW 2006-01-10 03:14:23 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (compatible; MSIE 6.0; Windows; U; AIIEEEE!; Win98; Windows 98; en-US; Gecko masquerading as IE; should it matter?; rv:1.8b) Gecko/20050217

Description of problem:
If you loop-mount a file and modify the mounted filesystem the modify time of the underlying file doesn't change even though the file really has changed. Ouch! Entire files avoid backup because they don't appear to have changed - but they have.



Version-Release number of selected component (if applicable):
kernel-2.6.14-1.1644_FC4

How reproducible:
Always

Steps to Reproduce:
1.dd ibs=1024 count=10240 if=/dev/zero of=img
2.mke2fs -m0 -F img
3.touch -t 200001011400 img 
4.mount -o loop img /mnt/somewhere
5.touch /mnt/somewhere/newfile
6.umount /mnt/somewhere
7.ls -l img

  

Actual Results:  -rw-r--r--  1 root root 10485760 Jan  1  2000 img


Expected Results:  -rw-r--r--  1 root root 10485760 Jan 10 19:17 img



Additional info:
Comment 1 Dave Jones 2006-02-03 02:05:05 EST
This is a mass-update to all currently open kernel bugs.

A new kernel update has been released (Version: 2.6.15-1.1830_FC4)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO_REPORTER state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

Thank you.
Comment 2 JW 2006-03-17 02:04:47 EST
This bugs also arise when *any* file whatsoever is opened for writing without
truncation or changing the file size (ie binary patching).

That's right, any virus writers/NSA workers out there!  You can write to a Linux
executable, put whatever you like inside it, and not even the file modify time
will change.  You don't even have to 'touch' the file.

So much for SELinux! The most basic file modification-time updates do not work.
That makes Linux a greater security risk than the much-hated MS Windows.
Comment 3 Dave Jones 2006-09-16 22:42:54 EDT
[This comment added as part of a mass-update to all open FC4 kernel bugs]

FC4 has now transitioned to the Fedora legacy project, which will continue to
release security related updates for the kernel.  As this bug is not security
related, it is unlikely to be fixed in an update for FC4, and has been migrated
to FC5.

Please retest with Fedora Core 5.

Thank you.
Comment 4 Dave Jones 2006-10-16 17:42:35 EDT
A new kernel update has been released (Version: 2.6.18-1.2200.fc5)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

In the last few updates, some users upgrading from FC4->FC5
have reported that installing a kernel update has left their
systems unbootable. If you have been affected by this problem
please check you only have one version of device-mapper & lvm2
installed.  See bug 207474 for further details.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

If this bug has been fixed, but you are now experiencing a different
problem, please file a separate bug for the new problem.

Thank you.
Comment 5 petrosyan 2008-03-10 19:55:35 EDT
Fedora Core 5 is no longer maintained. Is this bug still present in Fedora 7 or
Fedora 8?
Comment 6 JW 2008-03-10 20:30:46 EDT
(In reply to comment #5)
> Fedora Core 5 is no longer maintained. Is this bug still present in Fedora 7 or
> Fedora 8?

In the time it took you to write that, you could have tried it and found the
answer for yourself.
Comment 7 Bug Zapper 2008-04-03 22:06:12 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.
http://fedoraproject.org/wiki/LifeCycle/EOL

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 8 Chuck Ebbert 2008-04-16 22:08:00 EDT
(In reply to comment #2)
> This bugs also arise when *any* file whatsoever is opened for writing without
> truncation or changing the file size (ie binary patching).
> 

It only happens when mounting a loopback device.
Comment 9 JW 2008-04-16 22:18:50 EDT
That is correct (at least with fc8).  It currently only happens with a loop
mounted file. Even though the file's content gets changed, the file's timestamp
never changes.

Not very clever if your backup method depends on changes in timestamps.  This
can mean that any loop mountable file will NEVER get backed up, despite changes
occurring therein.
Comment 10 Bug Zapper 2008-11-26 01:54:21 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Bug Zapper 2009-11-18 02:52:03 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 12 JW 2009-11-27 05:05:55 EST
Still a problem in fc12.

Modification to a loop-mounted filesystem does not update the mtime of the container file.
Comment 13 Bug Zapper 2010-11-04 08:17:46 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 JW 2010-11-04 08:27:59 EDT
Still a problem in fedora 14.
Comment 15 Ben Walton 2011-09-16 10:08:11 EDT
Problem exists in RHEL6 (and presumably 4 and 5 too).  Bugzilla 367691 indicates that this problem was sent upstream and also included a patch that looks sane.  That bug is marked closed though.

I see that a patch was accepted in 2010: https://lkml.org/lkml/2010/4/8/113

As git.kernel.org is still down, I'm not sure which tagged release this was in...any chance of this being backported to RHEL6?
Comment 16 Ben Walton 2011-09-18 13:43:15 EDT
git blame drivers/block/loop.c indicates commit 02246c4 is the fix for this issue in the kernel tree.

git tag --contains 02246c4 indicates that this patch went into v2.6.34.  Is there any change of having this fix back ported?

Thanks
-Ben
Comment 17 Ben Walton 2011-09-18 13:47:42 EDT
git blame drivers/block/loop.c indicates commit 02246c4 is the fix for this issue in the kernel tree.

git tag --contains 02246c4 indicates that this patch went into v2.6.34.  Is there any chance of having this fix back ported?

Thanks
-Ben
Comment 18 Fedora End Of Life 2012-08-16 17:38:05 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Note You need to log in before you can comment on or make changes to this bug.